Index: trunk/source/processes/hadronic/models/de_excitation/multifragmentation/src/G4StatMFMacroTemperature.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/multifragmentation/src/G4StatMFMacroTemperature.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/multifragmentation/src/G4StatMFMacroTemperature.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4StatMFMacroTemperature.cc,v 1.7 2008/11/19 14:33:31 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4StatMFMacroTemperature.cc,v 1.8 2010/04/16 17:04:08 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -36,6 +36,30 @@
 //          Moscow, pshenich@fias.uni-frankfurt.de) make algorithm closer to
 //          original MF model
+// 16.04.10 V.Ivanchenko improved logic of solving equation for tempetature
+//          to protect code from rare unwanted exception; moved constructor 
+//          and destructor to source  
 
 #include "G4StatMFMacroTemperature.hh"
+
+G4StatMFMacroTemperature::G4StatMFMacroTemperature(const G4double anA, const G4double aZ, 
+  const G4double ExEnergy, const G4double FreeE0, const G4double kappa, 
+  std::vector<G4VStatMFMacroCluster*> * ClusterVector) :
+  theA(anA),
+  theZ(aZ),
+  _ExEnergy(ExEnergy),
+  _FreeInternalE0(FreeE0),
+  _Kappa(kappa),
+  _MeanMultiplicity(0.0),
+  _MeanTemperature(0.0),
+  _ChemPotentialMu(0.0),
+  _ChemPotentialNu(0.0),
+  _theClusters(ClusterVector) 
+{}
+
+G4StatMFMacroTemperature::G4StatMFMacroTemperature() 
+{}
+	
+G4StatMFMacroTemperature::~G4StatMFMacroTemperature() 
+{}
 
 // operators definitions
@@ -82,5 +106,5 @@
 
     G4int iterations = 0;  
-    while (fTa < 0.0 && iterations++ < 10) {
+    while (fTa < 0.0 && ++iterations < 10) {
 	Ta -= 0.5*Ta;
 	fTa = this->operator()(Ta);
@@ -89,5 +113,5 @@
     iterations = 0;  
     while (fTa*fTb > 0.0 && iterations++ < 10) {
-	Tb += 2.*std::abs(Tb-Ta);
+	Tb += 2.*std::fabs(Tb-Ta);
 	fTb = this->operator()(Tb);
     }
@@ -96,5 +120,5 @@
       G4cerr <<"G4StatMFMacroTemperature:"<<" Ta="<<Ta<<" Tb="<<Tb<< G4endl;
       G4cerr <<"G4StatMFMacroTemperature:"<<" fTa="<<fTa<<" fTb="<<fTb<< G4endl;
-	throw G4HadronicException(__FILE__, __LINE__, "G4StatMFMacroTemperature::CalcTemperature: I couldn't bracket the solution.");
+      throw G4HadronicException(__FILE__, __LINE__, "G4StatMFMacroTemperature::CalcTemperature: I couldn't bracket the solution.");
     }
 
@@ -102,6 +126,6 @@
     theSolver->SetIntervalLimits(Ta,Tb);
     if (!theSolver->Crenshaw(*this)){ 
-      G4cerr <<"G4StatMFMacroTemperature, Crenshaw method failed:"<<" Ta="<<Ta<<" Tb="<<Tb<< G4endl;
-      G4cerr <<"G4StatMFMacroTemperature, Crenshaw method failed:"<<" fTa="<<fTa<<" fTb="<<fTb<< G4endl;
+      G4cout <<"G4StatMFMacroTemperature, Crenshaw method failed:"<<" Ta="<<Ta<<" Tb="<<Tb<< G4endl;
+      G4cout <<"G4StatMFMacroTemperature, Crenshaw method failed:"<<" fTa="<<fTa<<" fTb="<<fTb<< G4endl;
     }
     _MeanTemperature = theSolver->GetRoot();
@@ -111,24 +135,28 @@
     // Verify if the root is found and it is indeed within the physical domain, 
     // say, between 1 and 50 MeV, otherwise try Brent method:
-    if (_MeanTemperature < 1. || _MeanTemperature > 50. || std::abs(FunctionValureAtRoot) > 5.e-2) {
-    G4cout << "Crenshaw method failed; function = " << FunctionValureAtRoot << " solution? = " << _MeanTemperature << " MeV " << G4endl;
-    G4Solver<G4StatMFMacroTemperature> * theSolverBrent = new G4Solver<G4StatMFMacroTemperature>(200,1.e-3);
-    theSolverBrent->SetIntervalLimits(Ta,Tb);
-    if (!theSolverBrent->Brent(*this)){
-      G4cerr <<"G4StatMFMacroTemperature, Brent method failed:"<<" Ta="<<Ta<<" Tb="<<Tb<< G4endl;
-      G4cerr <<"G4StatMFMacroTemperature, Brent method failed:"<<" fTa="<<fTa<<" fTb="<<fTb<< G4endl; 
+    if (std::fabs(FunctionValureAtRoot) > 5.e-2) {
+      if (_MeanTemperature < 1. || _MeanTemperature > 50.) {
+	G4cout << "Crenshaw method failed; function = " << FunctionValureAtRoot 
+	       << " solution? = " << _MeanTemperature << " MeV " << G4endl;
+	G4Solver<G4StatMFMacroTemperature> * theSolverBrent = new G4Solver<G4StatMFMacroTemperature>(200,1.e-3);
+	theSolverBrent->SetIntervalLimits(Ta,Tb);
+	if (!theSolverBrent->Brent(*this)){
+	  G4cout <<"G4StatMFMacroTemperature, Brent method failed:"<<" Ta="<<Ta<<" Tb="<<Tb<< G4endl;
+	  G4cout <<"G4StatMFMacroTemperature, Brent method failed:"<<" fTa="<<fTa<<" fTb="<<fTb<< G4endl; 
+	  throw G4HadronicException(__FILE__, __LINE__, "G4StatMFMacroTemperature::CalcTemperature: I couldn't find the root with any method.");
+	}
+
+	_MeanTemperature = theSolverBrent->GetRoot();
+	FunctionValureAtRoot =  this->operator()(_MeanTemperature);
+	delete theSolverBrent;
+      }
+      if (std::abs(FunctionValureAtRoot) > 5.e-2) {
+	//if (_MeanTemperature < 1. || _MeanTemperature > 50. || std::abs(FunctionValureAtRoot) > 5.e-2) {
+	G4cout << "Brent method failed; function = " << FunctionValureAtRoot << " solution? = " << _MeanTemperature << " MeV " << G4endl;
 	throw G4HadronicException(__FILE__, __LINE__, "G4StatMFMacroTemperature::CalcTemperature: I couldn't find the root with any method.");
-    }
-
-    _MeanTemperature = theSolverBrent->GetRoot();
-    FunctionValureAtRoot =  this->operator()(_MeanTemperature);
-    delete theSolverBrent;
-
-     if (_MeanTemperature < 1. || _MeanTemperature > 50. || std::abs(FunctionValureAtRoot) > 5.e-2) {
-    G4cout << "Brent method failed; function = " << FunctionValureAtRoot << " solution? = " << _MeanTemperature << " MeV " << G4endl;
-	throw G4HadronicException(__FILE__, __LINE__, "G4StatMFMacroTemperature::CalcTemperature: I couldn't find the root with any method.");
-     }
-    }
-
+      }
+    }
+    //G4cout << "G4StatMFMacroTemperature::CalcTemperature: function = " << FunctionValureAtRoot 
+    //	   << " T(MeV)= " << _MeanTemperature << G4endl;
     return _MeanTemperature;
 }
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4ContinuumGammaDeexcitation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4ContinuumGammaDeexcitation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4ContinuumGammaDeexcitation.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4ContinuumGammaDeexcitation.hh,v 1.4 2010/04/25 18:43:21 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -64,5 +66,5 @@
 
   // Destructor
-  ~G4ContinuumGammaDeexcitation();
+  virtual ~G4ContinuumGammaDeexcitation();
 
   // Functions
@@ -72,5 +74,5 @@
   virtual G4VGammaTransition* CreateTransition();
 
-  virtual G4bool CanDoTransition() const;
+  virtual G4bool CanDoTransition();
 
 private:
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaDeexcitation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaDeexcitation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaDeexcitation.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4DiscreteGammaDeexcitation.hh,v 1.4 2010/04/25 18:43:21 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -51,4 +53,5 @@
 // -------------------------------------------------------------------
 //
+
 #ifndef G4DiscreteGammaDeexcitation_hh
 #define G4DiscreteGammaDeexcitation_hh
@@ -71,5 +74,5 @@
 
   // Destructor
-  ~G4DiscreteGammaDeexcitation();
+  virtual ~G4DiscreteGammaDeexcitation();
 
   // Functions
@@ -79,5 +82,5 @@
   virtual G4VGammaTransition * CreateTransition();
 
-  virtual G4bool CanDoTransition() const;
+  virtual G4bool CanDoTransition();
 
   void SetICM(G4bool hl) { _icm = hl; };
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaTransition.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaTransition.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4DiscreteGammaTransition.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4DiscreteGammaTransition.hh,v 1.4 2010/04/25 18:43:21 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -52,5 +54,10 @@
 //        15 April 1999, Alessandro Brunengo (Alessandro.Brunengo@ge.infn.it)
 //              Added creation time evaluation for products of evaporation
+//
 //      
+//        19 April 2010, J. M. Quesada. 
+//              Corrections added for taking into account mismatch between tabulated 
+//              gamma energies and level energy differences (fake photons eliminated) 
+//   
 // -------------------------------------------------------------------
 
@@ -62,4 +69,7 @@
 #include "G4NuclearLevel.hh"
 
+//JMQ 180410
+class G4NuclearLevelManager;
+
 class G4DiscreteGammaTransition : public G4VGammaTransition
 {
@@ -68,5 +78,7 @@
   // Constructor
   G4DiscreteGammaTransition(const G4NuclearLevel& level);
-  G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z);
+//JMQ 180410
+//  G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z);
+  G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z, G4int A);
 
   // Destructor
@@ -99,4 +111,10 @@
   G4double _excitation;
   G4double _gammaCreationTime;
+  //JMQ 180410
+  G4int _A;
+  G4int _Z;
+  G4NuclearLevelManager * _levelManager;
+  //JMQ 190410
+  G4double _tolerance;
 };
 
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4E1Probability.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4E1Probability.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4E1Probability.hh	(revision 1315)
@@ -24,4 +24,16 @@
 // ********************************************************************
 //
+// $Id: G4E1Probability.hh,v 1.5 2010/05/19 10:21:44 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+//
+//---------------------------------------------------------------------
+//
+// Geant4 header G4E1Probability
+//
+// by V. Lara (May 2003)
+//
+// Modifications:
+// 18.05.2010 V.Ivanchenko trying to speedup the most slow method
+//            by usage of G4Pow, integer A and introduction of const members
 //
 //
@@ -33,5 +45,6 @@
 #include "G4VEmissionProbability.hh"
 #include "G4Fragment.hh"
-#include "G4VLevelDensityParameter.hh"
+
+class G4Pow;
 
 class G4E1Probability : public G4VEmissionProbability
@@ -40,7 +53,7 @@
 public:
 
-  G4E1Probability() {};
+  G4E1Probability();
 
-  ~G4E1Probability();
+  virtual ~G4E1Probability();
 
   G4double EmissionProbability(const G4Fragment& frag, const G4double excite);
@@ -48,6 +61,4 @@
 
 private:
-
-  // G4E1Probability() {};
 
   G4E1Probability(const G4E1Probability& right);
@@ -58,10 +69,12 @@
 
   // Integrator (simple Gaussian quadrature)
-
   G4double EmissionIntegration(const G4Fragment& frag, const G4double excite,
                                const G4double lowLim, const G4double upLim,
                                const G4int numIters);
 
-  // G4VLevelDensityParameter* _levelDensity; // Don't need this
+  // members
+  G4Pow*   fG4pow;
+  G4double theLevelDensityParameter;
+  G4double normC;
 
 };
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4PhotonEvaporation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4PhotonEvaporation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4PhotonEvaporation.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4PhotonEvaporation.hh,v 1.7 2010/05/11 11:22:14 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -36,7 +38,7 @@
 //      Creation date: 23 October 1998
 //
-//      Modifications:
+//Modifications:
 //
-//        18 October 2002, Fan Lei (flei@space.qinetiq.com)
+// 18 October 2002, Fan Lei (flei@space.qinetiq.com)
 //   
 //        Implementation of Internal Convertion process in discrete deexcitation
@@ -54,4 +56,7 @@
 //            G4ElectronOccupancy _eOccupancy;
 //            G4int _vShellNumber;
+//
+// 11 May 2010, V.Ivanchenko added EmittedFragment and BreakUpFragment
+//                           methods
 // 
 // -------------------------------------------------------------------
@@ -61,5 +66,4 @@
 
 #include "globals.hh"
-#include "G4VPhotonEvaporation.hh"
 #include "G4VEvaporationChannel.hh"
 #include "G4VEmissionProbability.hh"
@@ -67,9 +71,7 @@
 #include "G4ElectronOccupancy.hh"
 
-//#define debug
-
 class G4Fragment;
 
-class G4PhotonEvaporation : public G4VPhotonEvaporation, public G4VEvaporationChannel {
+class G4PhotonEvaporation : public G4VEvaporationChannel {
 
 public:
@@ -79,7 +81,11 @@
     virtual ~G4PhotonEvaporation();
 
+    virtual void Initialize(const G4Fragment & fragment);
+
+    virtual G4Fragment* EmittedFragment(G4Fragment* theNucleus);
+
+    virtual G4FragmentVector* BreakUpFragment(G4Fragment* theNucleus);
+
     virtual G4FragmentVector * BreakItUp(const G4Fragment & nucleus);
-
-    virtual void Initialize(const G4Fragment & fragment);
 
     virtual G4FragmentVector * BreakUp(const G4Fragment & nucleus);
@@ -99,5 +105,4 @@
     void SetEOccupancy( G4ElectronOccupancy  eOccupancy) ;
 
-
     G4ElectronOccupancy GetEOccupancy () { return _eOccupancy;} ;
    
@@ -111,23 +116,20 @@
     G4VGammaDeexcitation * _discrDeexcitation;
     G4VGammaDeexcitation * _contDeexcitation;
-  //    G4VGammaDeexcitation * _cdDeexcitation;
 
     G4ElectronOccupancy _eOccupancy;
     G4int _vShellNumber;
 
-    G4Fragment _nucleus;
+    G4Fragment* _nucleus;
     G4double _gammaE;
 
     G4PhotonEvaporation(const G4PhotonEvaporation & right);
-
     const G4PhotonEvaporation & operator = (const G4PhotonEvaporation & right);
 
-    // MGP - Check == and != multiple inheritance... must be a mess!
     G4bool operator == (const G4PhotonEvaporation & right) const;
     G4bool operator != (const G4PhotonEvaporation & right) const;
 
-#ifdef debug
-    void CheckConservation(const G4Fragment & theInitialState, G4FragmentVector * Result) const;
-#endif
+  //#ifdef debug
+  //  void CheckConservation(const G4Fragment & theInitialState, G4FragmentVector * Result) const;
+  //#endif
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VGammaDeexcitation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VGammaDeexcitation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VGammaDeexcitation.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4VGammaDeexcitation.hh,v 1.8 2010/04/28 14:22:40 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -37,4 +39,15 @@
 //
 //      Modifications:
+//          
+//        15 April 1999, Alessandro Brunengo (Alessandro.Brunengo@ge.infn.it)
+//              Added creation time evaluation for products of evaporation
+//
+//        21 Nov 2001, Fan Lei (flei@space.qinetiq.com)
+//           Modified GenerateGamma() and UpdateUncleus() for implementation
+//           of Internal Conversion processs
+// 
+//        8 March 2002, Fan Lei (flei@space.qinetiq.com)
+//          Added  SetEO () , GetEO(), UpdateElectrons() to allow the assignment 
+//          and modification of electron configuration.
 //
 //        18 October 2002, F. Lei
@@ -43,17 +56,9 @@
 //          Added SetVaccantSN(). It is need to to re-set _vSN after each 
 //          IC happened.
-// 
-//        8 March 2002, Fan Lei (flei@space.qinetiq.com)
-//          Added  SetEO () , GetEO(), UpdateElectrons() to allow the assignment 
-//          and modification of electron configuration.
-//          
-//        21 Nov 2001, Fan Lei (flei@space.qinetiq.com)
-//           Modified GenerateGamma() and UpdateUncleus() for implementation
-//           of Internal Conversion processs
 //
-//        15 April 1999, Alessandro Brunengo (Alessandro.Brunengo@ge.infn.it)
-//              Added creation time evaluation for products of evaporation
+//        28 April 2010, V.Ivanchenko cleanup methods
 //
 // -------------------------------------------------------------------
+//
 
 #ifndef G4VGAMMADEEXCITATION_HH
@@ -70,53 +75,76 @@
 public:
 
-    G4VGammaDeexcitation();
+  G4VGammaDeexcitation();
 
-    virtual ~G4VGammaDeexcitation();
+  virtual ~G4VGammaDeexcitation();
 
-    virtual G4VGammaTransition * CreateTransition() = 0;
-    virtual G4bool CanDoTransition() const = 0;
+  virtual G4VGammaTransition * CreateTransition() = 0;
+  virtual G4bool CanDoTransition() = 0;
 
-    // Single gamma transition
-    virtual G4FragmentVector * DoTransition();
+  // Single gamma transition
+  G4FragmentVector * DoTransition();
 
-    // Chain of gamma transitions
-    virtual G4FragmentVector * DoChain();
+  // Chain of gamma transitions
+  G4FragmentVector * DoChain();
 
-    virtual G4Fragment * GenerateGamma();
+  G4Fragment * GenerateGamma();
 
-    virtual const G4Fragment & GetNucleus() const;
+  inline G4Fragment* GetNucleus();
 
-    virtual void SetNucleus(const G4Fragment & nucleus);
+  inline void SetNucleus(G4Fragment* nucleus);
 
-    virtual void SetVerboseLevel(G4int verbose);
+  inline void SetVerboseLevel(G4int verbose);
 
-    void SetEO(G4ElectronOccupancy eo) { _electronO = eo; };
-    void SetVaccantSN( G4int val ) { _vSN = val;};
+  inline void Initialize();
+
+  void SetEO(G4ElectronOccupancy eo) { _electronO = eo; };
+  void SetVaccantSN( G4int val ) { _vSN = val;};
   
-    G4ElectronOccupancy GetEO() { return _electronO; };    
-    G4int GetVacantSN() {return _vSN;};
+  G4ElectronOccupancy GetEO() { return _electronO; };    
+  G4int GetVacantSN() {return _vSN;};
+
 protected:
 
-    void Initialize();
-    void UpdateNucleus(const G4Fragment * gamma);
-    void UpdateElectrons ();
-    void Update();
+  void Update();
 
-    G4VGammaTransition * _transition; // Owned pointer
-    G4int _verbose;
+  G4VGammaTransition* _transition; // Owned pointer
+  G4int _verbose;
 
 private:
 
-    G4Fragment _nucleus;
-    G4ElectronOccupancy _electronO;
-    G4int _vSN;
+  G4Fragment* _nucleus;
+  G4ElectronOccupancy _electronO;
+  G4int _vSN;
 
-    G4VGammaDeexcitation(const G4VGammaDeexcitation & right);
-
-    const G4VGammaDeexcitation & operator = (const G4VGammaDeexcitation & right);
-    G4bool operator == (const G4VGammaDeexcitation & right) const;
-    G4bool operator != (const G4VGammaDeexcitation & right) const;
+  G4VGammaDeexcitation(const G4VGammaDeexcitation & right);
+  const G4VGammaDeexcitation & operator = (const G4VGammaDeexcitation & right);
+  G4bool operator == (const G4VGammaDeexcitation & right) const;
+  G4bool operator != (const G4VGammaDeexcitation & right) const;
 
 };
+
+inline G4Fragment* G4VGammaDeexcitation::GetNucleus() 
+{
+  return _nucleus; 
+}
+
+inline void G4VGammaDeexcitation::SetNucleus(G4Fragment* nucleus)
+{
+  _nucleus = nucleus;
+}
+
+inline void G4VGammaDeexcitation::SetVerboseLevel(G4int verbose)
+{
+  _verbose = verbose;
+}
+
+inline void G4VGammaDeexcitation::Initialize()
+{
+  if (_transition != 0) { delete _transition; }
+  _transition = CreateTransition();
+  if (_transition != 0) {
+    _transition->SetEnergyFrom(_nucleus->GetExcitationEnergy());
+  }
+}
 
 #endif
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VPhotonEvaporation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VPhotonEvaporation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/include/G4VPhotonEvaporation.hh	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4VPhotonEvaporation.hh,v 1.3 2010/04/25 18:43:21 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaDeexcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaDeexcitation.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaDeexcitation.cc	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4ContinuumGammaDeexcitation.cc,v 1.7 2010/04/30 16:08:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -40,4 +42,6 @@
 //
 //      02 May 2003,   Vladimir Ivanchenko change interface to G4NuclearlevelManager
+//
+//      19 April 2010 J. M. Quesada: smaller value of tolerance parameter
 //      
 // -------------------------------------------------------------------
@@ -61,5 +65,6 @@
 //
 
-G4ContinuumGammaDeexcitation::G4ContinuumGammaDeexcitation(): _nucleusZ(0), _nucleusA(0), _levelManager(0)
+G4ContinuumGammaDeexcitation::G4ContinuumGammaDeexcitation()
+  : _nucleusZ(0), _nucleusA(0), _levelManager(0)
 { }
 
@@ -71,8 +76,8 @@
 G4VGammaTransition* G4ContinuumGammaDeexcitation::CreateTransition()
 {
-  G4Fragment nucleus = GetNucleus();
-  G4int Z = static_cast<G4int>(nucleus.GetZ());
-  G4int A = static_cast<G4int>(nucleus.GetA());
-  G4double excitation = nucleus.GetExcitationEnergy();
+  G4Fragment* nucleus = GetNucleus();
+  G4int Z = static_cast<G4int>(nucleus->GetZ());
+  G4int A = static_cast<G4int>(nucleus->GetA());
+  G4double excitation = nucleus->GetExcitationEnergy();
 
   if (_nucleusA != A || _nucleusZ != Z)
@@ -83,7 +88,7 @@
     }
 
-  if (_verbose > 1)
+  if (_verbose > 1) {
     G4cout << "G4ContinuumGammaDeexcitation::CreateTransition - Created" << G4endl;
-
+  }
   G4VGammaTransition* gt =  new G4ContinuumGammaTransition(_levelManager,Z,A,excitation,_verbose );
 
@@ -92,60 +97,61 @@
     
 
-G4bool G4ContinuumGammaDeexcitation::CanDoTransition() const
+G4bool G4ContinuumGammaDeexcitation::CanDoTransition() 
 {
- G4bool canDo = true;
+  //JMQ: far too small, creating sometimes continuum gammas instead of the right discrete ones
+  // (when excitation energy is slightly over maximum discrete  energy): changed
+  //  G4double tolerance = 10*eV;
+  const G4double tolerance = CLHEP::keV;
 
   if (_transition == 0) 
     {
-      canDo = false;
-
-      if (_verbose > 0)
-	G4cout 
-	  << "G4ContinuumGammaDeexcitation::CanDoTransition - Null transition "
-	  << G4endl;
+      if (_verbose > 0) {
+	G4cout << "G4ContinuumGammaDeexcitation::CanDoTransition - Null transition "
+	       << G4endl;
+      }
+      return false;
     }
 
-  G4Fragment nucleus = GetNucleus();
-  G4double excitation = nucleus.GetExcitationEnergy();
+  G4Fragment* nucleus = GetNucleus();
+  G4double excitation = nucleus->GetExcitationEnergy();
 
-  G4double A = nucleus.GetA();
-  G4double Z = nucleus.GetZ();
-  if (A <2 || Z<3)
+  //  G4int A = (G4int)nucleus->GetA();
+  // G4int Z = (G4int)nucleus->GetZ();
+  if (_nucleusA<2 || _nucleusZ<3)
     {
-      canDo = false;
-      if (_verbose > 0) 
-	G4cout 
-	  << "G4ContinuumGammaDeexcitation::CanDoTransition - n/p/H"
-	  << G4endl;
+      if (_verbose > 1) { 
+	G4cout << "G4ContinuumGammaDeexcitation::CanDoTransition - n/p/H"
+	       << G4endl;
+      }
+      return false;
     }
 
-
-
-  if (excitation <= 0.) 
+  if (excitation <= tolerance) 
     {
-      canDo = false;
-      if (_verbose > 0) 
-	G4cout 
-	  << "G4ContinuumGammaDeexcitation::CanDoTransition -  Excitation <= 0"
-	  << G4endl;
+      if (_verbose > 1) { 
+	G4cout << "G4ContinuumGammaDeexcitation::CanDoTransition -  Excitation "
+	       << excitation/CLHEP::keV << " keV is too small"
+	       << G4endl;
+      }
+      return false;
     }
-  G4double tolerance = 10*eV;
-  if (excitation <= (_levelManager->MaxLevelEnergy()+ tolerance)) 
-    {
-      canDo = false;  
-      if (_verbose > 0)
-      G4cout << "G4ContinuumGammaDeexcitation::CanDoTransition -  Excitation " 
-	     << excitation << " below max discrete level " 
-	     << _levelManager->MaxLevelEnergy() << G4endl;
+  if (excitation <= (_levelManager->MaxLevelEnergy() + tolerance)) 
+    {  
+      if (_verbose > 0) {
+	G4cout << "G4ContinuumGammaDeexcitation::CanDoTransition -  Excitation " 
+	       << excitation << " below max discrete level " 
+	       << _levelManager->MaxLevelEnergy() << G4endl;
+      }
+      return false;
     }
   
-  if (canDo)
-    { if (_verbose > 1) 
-      G4cout <<"G4ContinuumGammaDeexcitation::CanDoTransition - CanDo" 
-	     << G4endl; 
-    }
-
-  return canDo;
-
+  if (_verbose > 1) {
+    G4cout <<"G4ContinuumGammaDeexcitation::CanDoTransition - CanDo" 
+	   << " Eex(keV)= " << excitation/CLHEP::keV 
+	   << " Emax(keV)= " << _levelManager->MaxLevelEnergy()/CLHEP::keV 
+	   << " Z= " << _nucleusZ << " A= " << _nucleusA
+	   << G4endl;
+  }
+  return true;
 }
 
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc	(revision 1315)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4DiscreteGammaDeexcitation.cc,v 1.15 2010/05/10 07:20:40 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -65,17 +67,17 @@
   _rdm(false), _levelManager(0)
 {
-  _tolerance = 0.1 * MeV;
+  _tolerance = CLHEP::keV;
 }
 
-
-G4DiscreteGammaDeexcitation::~G4DiscreteGammaDeexcitation() {}
-
+G4DiscreteGammaDeexcitation::~G4DiscreteGammaDeexcitation() 
+{}
 
 G4VGammaTransition* G4DiscreteGammaDeexcitation::CreateTransition()
 {
-  G4Fragment nucleus = GetNucleus();
-  G4int A = static_cast<G4int>(nucleus.GetA());
-  G4int Z = static_cast<G4int>(nucleus.GetZ());
-
+  G4Fragment* nucleus = GetNucleus();
+  G4int A = static_cast<G4int>(nucleus->GetA());
+  G4int Z = static_cast<G4int>(nucleus->GetZ());
+  //  _verbose =2;
+  //  G4cout << "G4DiscreteGammaDeexcitation::CreateTransition: " << nucleus << G4endl;
   if (_nucleusA != A || _nucleusZ != Z) 
     {
@@ -84,6 +86,4 @@
       _levelManager = G4NuclearLevelStore::GetInstance()->GetManager(Z,A);
     }
-
-
 
   if (_levelManager->IsValid()) 
@@ -96,16 +96,16 @@
 	}
 	
-      G4double excitation = nucleus.GetExcitationEnergy();
-      //      const G4NuclearLevel* level =_levelManager.NearestLevel(excitation, _tolerance);
+      G4double excitation = nucleus->GetExcitationEnergy();
       const G4NuclearLevel* level =_levelManager->NearestLevel(excitation);
 	
       if (level != 0)  
 	{ 
-	  if (_verbose > 0)
+	  if (_verbose > 0) {
 	    G4cout 
 	      << "G4DiscreteGammaDeexcitation::CreateTransition - Created from level energy " 
 	      << level->Energy() << ", excitation is " 
 	      << excitation << G4endl;
-	  G4DiscreteGammaTransition* dtransit = new G4DiscreteGammaTransition(*level,Z);
+	  }
+	  G4DiscreteGammaTransition* dtransit = new G4DiscreteGammaTransition(*level,Z,A);
 	  dtransit->SetICM(_icm);  
 	  return dtransit;
@@ -113,17 +113,17 @@
       else 
 	{ 
-	  if (_verbose > 0)
+	  if (_verbose > 0) {
 	    G4cout 
 	      << "G4DiscreteGammaDeexcitation::CreateTransition - No transition created from "
 	      << excitation << " within tolerance " << _tolerance << G4endl;
-	    
+	  }
 	  return 0; 
 	}
     }
-  else return 0;
+  return 0;
 }
 
 
-G4bool G4DiscreteGammaDeexcitation::CanDoTransition() const
+G4bool G4DiscreteGammaDeexcitation::CanDoTransition() 
 {
 
@@ -138,9 +138,6 @@
 	<< G4endl;
   } 
-  G4Fragment nucleus = GetNucleus();
   if (canDo)  {
-    G4double A = nucleus.GetA();
-    G4double Z = nucleus.GetZ();
-    if (Z<2 || A<3 || Z>98)
+    if (_nucleusZ<2 || _nucleusA<3 || _nucleusZ>98)
       {
 	canDo = false;
@@ -152,19 +149,23 @@
   }
 
-  G4double excitation = nucleus.GetExcitationEnergy();
+  G4Fragment* nucleus = GetNucleus();
+  G4double excitation = nucleus->GetExcitationEnergy();
+  //G4cout << "G4DiscreteGammaDeexcitation::CanDoTransition: " << nucleus << G4endl;
 
   if (canDo) {
-    if (excitation <= 0.) {
+    if (excitation <= _tolerance) {
       canDo = false;
-      if (_verbose > 0) 
+      if (_verbose > 0) {
 	G4cout 
 	  << "G4DiscreteGammaDeexcitation::CanDoTransition -  Excitation <= 0" 
+	  << excitation << "  " << excitation - _tolerance
 	  << G4endl;
+      }
     } else { 
       if (excitation > _levelManager->MaxLevelEnergy() + _tolerance) canDo = false;
-      if (excitation < _levelManager->MinLevelEnergy() - _tolerance) canDo = false;  
+      //if (excitation < _levelManager->MinLevelEnergy() - _tolerance) canDo = false;  
       // The following is a protection to avoid looping in case of elements with very low
       // ensdf levels
-      if (excitation < _levelManager->MinLevelEnergy() * 0.9) canDo = false;  
+      //if (excitation < _levelManager->MinLevelEnergy() * 0.9) canDo = false;  
   
       if (_verbose > 0) {
